﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
Sub Class_Globals
	Private scannerStream As AsyncStreams
	Private scanner As Serial
	Private BTadmin As BluetoothAdmin
	Dim scannerMacandName As Map
	Public BluetoothState, ConnectionState As Boolean
End Sub

Public Sub Initialize
	BTadmin.Initialize("BTadmin")
	scanner.Initialize("scanner")
End Sub

public Sub CheckBluetoothState As ResumableSub
	BluetoothState = False
	Do While Not(BluetoothState)
		If BTadmin.IsEnabled Then
			BluetoothState = True
		Else		
			If BTadmin.Enable = False Then
				BluetoothState = False
				Exit	
			Else
				ToastMessageShow("Enabling Bluetooth adapter...", False)
			End If
		End If
	Loop
	
	Return BluetoothState
	
End Sub

Private Sub BTAdmin_StateChanged (NewState As Int, OldState As Int)
	Log("state changed: " & NewState)
	BluetoothState = NewState = BTadmin.STATE_ON
	NotifyOfStateChanged
End Sub

Public Sub ConnectTo(MacAddress As String)
	scanner.Connect(MacAddress)
End Sub

Private Sub scanner_Connected (Success As Boolean)
	ConnectionState = Success
	If Success = False Then
		Log(LastException.Message)
	Else
		If scannerStream.IsInitialized Then
			scannerStream.Close
		End If
		scannerStream.Initialize(scanner.InputStream, Null, "scannerStream")
	End If
	NotifyOfStateChanged
End Sub

Private Sub scannerStream_NewData (Buffer() As Byte)
	Dim sCode As String = BytesToString(Buffer, 0, Buffer.Length, "UTF8")
	Log(sCode)
	If Main.CurrentActivity <> "" And Not(IsPaused(Main.CurrentActivity)) Then
		If SubExists(Main.CurrentActivity, "BarcodeScanned") Then
			CallSubDelayed2(Main.CurrentActivity, "BarcodeScanned", sCode)
		End If
	End If
End Sub

Private Sub scannerStream_Error
	ToastMessageShow("Connection is broken.", True)
	ConnectionState = False
	NotifyOfStateChanged
End Sub

Private Sub scannerStream_Terminated
	scannerStream_Error
End Sub

Public Sub Disconnect
	If scannerStream.IsInitialized Then scannerStream.Close
	scanner.Disconnect
End Sub

Private Sub BTadmin_DeviceFound (DeviceName As String, MacAddress As String)
	If DeviceName.Trim.Length > 0 And Not(scannerMacandName.ContainsKey(MacAddress)) Then
		scannerMacandName.Put(MacAddress, DeviceName)
	End If	
End Sub

Public Sub ListenForConnections
	Dim i As Intent
	i.Initialize("android.bluetooth.adapter.action.REQUEST_DISCOVERABLE", "")
	i.PutExtra("android.bluetooth.adapter.extra.DISCOVERABLE_DURATION", 300)
	StartActivity(i)
	scanner.Listen
End Sub

Private Sub NotifyOfStateChanged
End Sub